/***************************************************************

This project is a mashup of the AudioRecordingDemo and the
plugin template project from the Projucer.  This particular
example does not actually make any sound.  The only purpose
of it is figure out how to get the mic input to work. It only
works in some cases:
  - AU on macOS
  - AUv3 on iOS
 
But does NOT work in these cases:
  - standalone on macOS
  - AUv3 on macOS
  - Standalone on iOS

Here is how this project was modified to integrate mic input:

- Create the default template project for an audio plugin
 
- Change to the .jucer file:
  - Define a company name
  - Define AUv3, AU, and standalone
  - Check Plugin is a synth
  - For the iOS and macOS xcode exporters enable microphone access

- Changes to merge in AudioRecordingDemo
  - Search for NICK_CHANGES
 
- When building, enabe automatic code signing and pick a team

***************************************************************/

#define NICK_CHANGES
/*  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"
#ifdef NICK_CHANGES
#include "AudioRecordingDemoClasses.h"
#endif
#include "PluginProcessor.h"

//==============================================================================
/**
*/
class MicPluginTestAudioProcessorEditor  : public AudioProcessorEditor
{
public:
    MicPluginTestAudioProcessorEditor (MicPluginTestAudioProcessor&);
    ~MicPluginTestAudioProcessorEditor();
#ifdef NICK_CHANGES
    AudioDeviceManager audioDeviceManager;
    File lastRecording;
    RecordingThumbnail recordingThumbnail;
    AudioRecorder recorder  { recordingThumbnail.getAudioThumbnail() };
    LiveScrollingAudioDisplay liveAudioScroller;
    TextButton recordSampleButton { "Record" };
    void startRecording();
    void stopRecording();
#endif

    //==============================================================================
    void paint (Graphics&) override;
    void resized() override;

private:
    // This reference is provided as a quick way for your editor to
    // access the processor object that created it.
    MicPluginTestAudioProcessor& processor;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MicPluginTestAudioProcessorEditor)
};
